/*
 * Copyright (C) 2010 David Arkell.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gwtorbit.client.model;

import java.util.ArrayList;

public class UiLocalizedError implements UiError {

	private static final long serialVersionUID = 1L;

	public static UiLocalizedError MANDATORY = new UiLocalizedError("err.mandatory");

	public static UiLocalizedError INVALID = new UiLocalizedError("err.invalid");

	public UiLocalizedError() {

	}

	public UiLocalizedError(String key, String... params) {
		this.key = key;
		for (String param : params) {
			this.params.add(param);
		}
	}

	public UiLocalizedError(String key, ArrayList<String> params) {
		this.key = key;
		this.params = params;
	}

	private String key;

	private ArrayList<String> params = new ArrayList<String>();

	public void setKey(String key) {
		this.key = key;
	}

	public String getKey() {
		return key;
	}

	public ArrayList<String> getParams() {
		return params;
	}

	public void setParams(ArrayList<String> params) {
		this.params = params;
	}

}
