package com.gwtorbit.client.widgets;

import java.util.Iterator;

import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

public class BVerticalPanel extends VerticalPanel {

	public BVerticalPanel() {
		inner = new VerticalPanel();
		super.add(inner);
	}

	public BVerticalPanel(Widget displayWhenEmpty) {
		this();
		setDisplayWhenEmpty(displayWhenEmpty);
	}

	private VerticalPanel inner;

	private Widget displayWhenEmpty;

	public void setDisplayWhenEmpty(Widget displayWhenEmpty) {
		if (this.displayWhenEmpty != null) {
			super.remove(displayWhenEmpty);
		}

		this.displayWhenEmpty = displayWhenEmpty;
		displayWhenEmpty.setVisible(inner.getWidgetCount() == 0);
		super.add(displayWhenEmpty);
	}

	public Widget getDisplayWhenEmpty() {
		return displayWhenEmpty;
	}

	public void add(Widget w) {
		inner.add(w);
	}

	public void clear() {
		inner.clear();
	}

	public Iterator<Widget> iterator() {
		return inner.iterator();
	}

	public boolean remove(Widget w) {
		return inner.remove(w);
	}

	public Widget getWidget(int index) {
		return inner.getWidget(index);
	}

	public int getWidgetCount() {
		return inner.getWidgetCount();
	}

	public int getWidgetIndex(Widget child) {
		return inner.getWidgetIndex(child);
	}

}
