/*
 * Copyright (C) 2010 David Arkell.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gwtorbit.client.widgets;

import com.google.gwt.user.client.ui.HasHTML;

public class FormLHTML extends FormAbstractRow implements HasHTML {

	private LHTML htmlPanel;

	public FormLHTML() {
		htmlPanel = new LHTML();
		setFieldWidget(htmlPanel);
	}

	public void setKey(String key) {
		htmlPanel.setKey(key);
	}

	public String getHTML() {
		return htmlPanel.getHTML();
	}

	public void setHTML(String html) {
		htmlPanel.setHTML(html);
	}

	public String getText() {
		return htmlPanel.getText();
	}

	public void setText(String text) {
		htmlPanel.setText(text);
	}

}
