/*
 * Copyright (C) 2010 David Arkell.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gwtorbit.client.widgets;

import com.google.gwt.user.client.ui.Label;
import com.gwtorbit.client.model.UiData;
import com.gwtorbit.client.model.UiDataDisplay;
import com.gwtorbit.client.model.UiErrors;
import com.gwtorbit.client.mvp.ClientResourceBundle;

public class UiLLabel extends Label implements UiDataDisplay {

	public void displayData(UiData uiData) {
		String val = null;
		if (dataName.indexOf(".") > -1) {
			String[] names = dataName.split("\\.");
			for (int i = 0; i < (names.length - 1); i++) {
				uiData = (UiData) uiData.getData(names[i]);
			}
			val = (String) uiData.getData(names[names.length - 1]);
		} else {
			val = (String) uiData.getData(dataName);
		}
		key = val;
		if (val == null) {
			setText("");
		} else {
			setText(ClientResourceBundle.getString(keyPrefix + key));
		}
	}

	public void getData(UiData uiData, UiErrors errors, String errorPrefix) {
		uiData.setData(dataName, key);
	}

	private String dataName;

	public String getDataName() {
		return dataName;
	}

	public void setDataName(String dataName) {
		this.dataName = dataName;
	}

	public void clearData() {
		setText("");
	}

	private boolean ignore = false;

	public boolean getIgnore() {
		return ignore;
	}

	public void setIgnore(boolean ignore) {
		this.ignore = ignore;
	}

	public void setKeyPrefix(String keyPrefix) {
		this.keyPrefix = keyPrefix;
	}

	public String getKeyPrefix() {
		return keyPrefix;
	}

	private String keyPrefix = "";

	private String key;
}
