package com.gwtorbit.client.widgets;

import com.google.gwt.user.client.ui.Label;
import com.gwtorbit.client.model.UiData;
import com.gwtorbit.client.model.UiDataDisplay;
import com.gwtorbit.client.model.UiErrors;
import com.gwtorbit.client.mvp.ClientResourceBundle;

public class UiLabelBoolean extends Label implements UiDataDisplay {

	public void displayData(UiData uiData) {
		if (ignore) {
			return;
		}

		if (dataName.indexOf(".") > -1) {
			String[] names = dataName.split("\\.");
			for (int i = 0; i < (names.length - 1); i++) {
				uiData = (UiData) uiData.getData(names[i]);
			}
			value = (Boolean) uiData.getData(names[names.length - 1]);
		} else {
			value = (Boolean) uiData.getData(dataName);
		}
		if (value == null) {
			this.setText("");
		} else {
			if (value) {
				setText(ClientResourceBundle.getString(trueLabelKey));
			} else {
				setText(ClientResourceBundle.getString(falseLabelKey));
			}
		}
	}

	public void getData(UiData uiData, UiErrors errors, String errorPrefix) {
		if (ignore) {
			return;
		}

		uiData.setData(dataName, value);
	}

	public void clearData() {
		if (ignore) {
			return;
		}

		setText("");
		value = null;
	}

	private String trueLabelKey = "UiLabelBoolean.trueLabel";

	private String falseLabelKey = "UiLabelBoolean.falseLabel";

	private Boolean value;

	private String dataName;

	private boolean ignore = false;

	public String getDataName() {
		return dataName;
	}

	public void setDataName(String dataName) {
		this.dataName = dataName;
	}

	public boolean getIgnore() {
		return ignore;
	}

	public void setIgnore(boolean ignore) {
		this.ignore = ignore;
	}

	public void setTrueLabelKey(String trueLabelKey) {
		this.trueLabelKey = trueLabelKey;
	}

	public String getTrueLabelKey() {
		return trueLabelKey;
	}

	public void setFalseLabelKey(String falseLabelKey) {
		this.falseLabelKey = falseLabelKey;
	}

	public String getFalseLabelKey() {
		return falseLabelKey;
	}

}
