package com.gwtorbit.client.widgets;

import com.google.gwt.user.client.ui.Label;
import com.gwtorbit.client.model.UiData;
import com.gwtorbit.client.model.UiDataDisplay;
import com.gwtorbit.client.model.UiErrors;
import com.gwtorbit.client.mvp.ClientResourceBundle;

public class UiLabelFileSize extends Label implements UiDataDisplay {

	public void displayData(UiData uiData) {
		if (ignore) {
			return;
		}

		if (dataName.indexOf(".") > -1) {
			String[] names = dataName.split("\\.");
			for (int i = 0; i < (names.length - 1); i++) {
				uiData = (UiData) uiData.getData(names[i]);
			}
			value = (Number) uiData.getData(names[names.length - 1]);
		} else {
			value = (Number) uiData.getData(dataName);
		}
		if (value == null) {
			setText("");
		} else {
			String sizeAsString = "";

			long size = value.longValue();
			if (size < 1024) { // less than 1KB
				sizeAsString = ClientResourceBundle.getString("page.label.fileSizeKB", "1");
			} else if (size < 1048576) { // less than 1MB
				size = (size + 1023) / 1024;
				sizeAsString = ClientResourceBundle.getString("page.label.fileSizeKB",
						ClientResourceBundle.integerFormat.format(size));
			} else { // 1MB and over
				size = (size + 1048575) / 1048576;
				sizeAsString = ClientResourceBundle.getString("page.label.fileSizeMB",
						ClientResourceBundle.integerFormat.format(size));
			}

			if (phraseKey == null) {
				setText(sizeAsString);
			} else {
				setText(ClientResourceBundle.getString(phraseKey, sizeAsString));
			}
		}
	}

	public void getData(UiData uiData, UiErrors errors, String errorPrefix) {
		if (ignore) {
			return;
		}

		uiData.setData(dataName, value);
	}

	public void clearData() {
		if (ignore) {
			return;
		}

		setText("");
		value = null;
	}

	private boolean ignore = false;

	private Number value;

	private String phraseKey;

	private String dataName;

	public String getDataName() {
		return dataName;
	}

	public void setDataName(String dataName) {
		this.dataName = dataName;
	}

	public boolean getIgnore() {
		return ignore;
	}

	public void setIgnore(boolean ignore) {
		this.ignore = ignore;
	}

	public void setPhraseKey(String phraseKey) {
		this.phraseKey = phraseKey;
	}

	public String getPhraseKey() {
		return phraseKey;
	}

}
